function [Sspec]    =   JDspectral(omeg,tau,tau_bar,tau_theta,rho,A,B,D,J,F,Veps)

L = exp(-sqrt(-1)*omeg);

Dspec = J*((tau + tau_bar*L)*inv((eye(size(A,1))-A*L))*B + tau_theta)*inv((eye(size(B,2))-rho*L))*D;

Sspec(:,:) = (Dspec)*Veps*(Dspec)'+F;