function [A,B1,Y,I,realrate_R,q_R,C,hours_R,Wage,index,II] = RBC(rho,D,pi,muzstar,beta,tauD,tauk,upsil,delta,lambdaf,alpha,b,taul,tauc, ...
    lambdaw,zeta,psiL,etag,Sdoupr,sigmaa,sigmaL,taushock,nameshocks,parstoch,stdshocks1,stdshocks2,Time,cshck, ...
    String1,index,II,ij,static,etai,util)

accuracy= 4.7730e-009;

[A,B,B1,P,c,y,g,i] = RBCsolve(rho,D,pi,muzstar,beta,tauD,tauk,upsil,delta,lambdaf,alpha,b,taul,tauc, ...
    lambdaw,zeta,psiL,etag,Sdoupr,sigmaa,sigmaL,taushock,parstoch,accuracy,static,etai,util);

%what follows does the simulation of the model
eps0 = zeros(size(D,2),1);

if (parstoch(taushock(ij))+2) == 2
    eps0(index+1,1) = stdshocks1(taushock(ij));  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    index = index+1;
    
    shock(:,1) = [D*eps0; zeros(size(D,1),1)];
    z1(:,1)    = B*shock(:,1);
    
    for t=2:Time,
        shock(:,t)=P*shock(:,t-1);
        z1(:,t)=A*z1(:,t-1)+B*shock(:,t);
    end
else
    eps0(index+2) = stdshocks2(taushock(ij));  %%%%%%%%%%%%%%%%%%%%%%%%%%
    
    shock(:,1) = [D*eps0; zeros(size(D,1),1)];
    z1(:,1)    = B*shock(:,1);
    
    for t=2:parstoch(taushock(ij))
        shock(:,t)=P*shock(:,t-1);
        z1(:,t)=A*z1(:,t-1)+B*shock(:,t);
    end
    
    t=parstoch(taushock(ij))+1;
    eps0 = zeros(size(D,2),1);
    eps0(index+1) = -stdshocks1(taushock(ij)); %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    shock(:,t)=P*shock(:,t-1) + [D*eps0; zeros(size(D,1),1)];
    z1(:,t)=A*z1(:,t-1)+B*shock(:,t);
    
    for t= (parstoch(taushock(ij))+2):Time
        shock(:,t)=P*shock(:,t-1);
        z1(:,t)=A*z1(:,t-1)+B*shock(:,t);
    end 
    index = index+2;
end

%unload shocks
lambdafhat=zeros(1,Time);
tauhat=zeros(1,Time);
psilhat=zeros(1,Time);    
psikhat=zeros(1,Time);
ksihat=zeros(1,Time);
xbhat=zeros(1,Time);
muuphat=zeros(1,Time);
chihat=zeros(1,Time);
ghat=zeros(1,Time);
taulhat=zeros(1,Time);
taukhat=zeros(1,Time);
zetahat=zeros(1,Time);
vhat = zeros(1,Time);
tauDhat = zeros(1,Time);
muzhat=zeros(1,Time); 
gammahat =zeros(1,Time);
epsilonhat = zeros(1,Time);
xphat = zeros(1,Time);
tauChat = zeros(1,Time);
sigmahat=zeros(1,Time);
sigmahatm1 =zeros(1,Time); %sigmahat(t-1)
zetachat = zeros(1,Time);
zetaihat = zeros(1,Time);
tauohat = zeros(1,Time);
termhat  =zeros(1,Time);

String=['Path followed by the shock in ' texlabel(nameshocks(taushock(ij),:))];
if taushock(ij) ==1
    lambdafhat = shock(II+1,1:Time);
    figure;plot(lambdafhat);title(String);
elseif taushock(ij) == 2
    tauhat=shock(II+1,1:Time);
    figure;plot(tauhat);title(String);
elseif taushock(ij) ==3
    psilhat=shock(II+1,1:Time);
    figure;plot(psilhat);title(String);
elseif taushock(ij) == 4
    psikhat=shock(II+1,1:Time);
    figure;plot(psikhat);title(String);
elseif taushock(ij) == 5
    ksihat= shock(II+1,1:Time);
    figure;plot(ksihat);title(String);
elseif taushock(ij) == 6
    xbhat=shock(II+1,1:Time);
    figure;plot(xbhat);title(String);
elseif taushock(ij) == 7
    muuphat=shock(II+1,1:Time);
    figure;plot(muuphat);title(String);
elseif taushock(ij) ==8
    thetahat=shock(II+1,1:Time);
    figure;plot(thetahat);title(String);
elseif taushock(ij) == 9
    chihat=shock(II+1,1:Time);
    figure;plot(chihat);title(String);
elseif taushock(ij) ==10
    taulhat = shock(II+1,1:Time);
    figure;plot(taulhat);title(String);
elseif taushock(ij) == 11
    taukhat = shock(II+1,1:Time);
    figure;plot(taukhat);title(String);
elseif taushock(ij) == 12
    zetahat=shock(II+1,1:Time);
    figure;plot(zetahat);title(String);
elseif taushock(ij) == 13
    ghat=shock(II+1,1:Time);
    figure;plot(ghat);title(String);
elseif taushock(ij) == 14
    vhat = shock(II+1,1:Time);
    figure;plot(vhat);title(String);
elseif taushock(ij) == 15
    tauDhat = shock(II+1,1:Time);
    figure;plot(tauDhat);title(String);
elseif taushock(ij)==16
    muzhat=shock(II+1,1:Time);
    figure;plot(muzhat);title(String);
elseif taushock(ij) == 17
    gammahat = shock(II+1,1:Time);
    figure;plot(gammahat);title(String);
elseif taushock(ij) == 18
    epsilonhat = shock(II+1,1:Time);
    figure;plot(epsilonhat);title(String);
elseif taushock(ij) == 19
    xphat = shock(II+1,1:Time);
    figure;plot(xphat);title(String);
elseif taushock(ij) == 20
    tauChat = shock(II+1,1:Time);
    figure;plot(tauChat);title(String);
elseif taushock(ij) == 21
    sigmahat=shock(II+1,1:Time);
    sigmahatm1=[0 shock(II+1,1:Time-1)];
    figure;plot(sigmahat);title(String);
elseif taushock(ij) == 22
    zetachat = shock(II+1,1:Time);
    figure;plot(zetachat);title(String);
elseif taushock(ij) == 23
    zetaihat = shock(II+1,1:Time);
    figure;plot(zetaihat);title(String);
elseif taushock(ij) == 24
    tauohat = shock(II+1,1:Time);
    figure;plot(tauohat);title(String);
elseif taushock(ij) == 25
    termhat = shock(II+1,1:Time);
    figure;plot(termhat);title(String);
end
II = II+2+parstoch(taushock(ij));


%unload the variables in z(t)
if max(max(abs(imag(z1)))) > .1e-10
    error('fatal (simulate) simulated data complex')
end
z1=real(z1);

hours_R = z1(2,:);
inv_R   = z1(3,:);
%util_R  = z1(4,:);
realrate_R = z1(6,:);
q_R       = z1(8,:);
con_R     = z1(11,:);
k_R       = z1(12,:);  
out_R      = (c/y).*z1(11,:) + (i/y).*z1(3,:) + (g/y).*ghat -(i/y).*muuphat;
wage_R    =z1(10,:);

for jj = 1:Time
    C(jj)=((1+con_R(jj))*cshck(jj))-1;
    I(jj)=((1+inv_R(jj))*cshck(jj))-1;
    kbart(jj)=((1+k_R(jj))*cshck(jj))-1;
    Y(jj)=((1+out_R(jj))*cshck(jj))-1;
    Wage(jj)=((1+wage_R(jj))*cshck(jj))-1; %real wage
end

do_plot=0;
if do_plot==1
    variables = strvcat('rk','l','i','u','ucz','RT','Rk','q','Lamz','w','c','K(t+1)');
    
    figure
    for j=1:size(z1,1)
        subplot(3,4,j)
        plot(z1(j,1:20))
        set (gca,'XTick',[0 20])
        title([texlabel(variables(j,:))]);
    end
    String1=['Response to a shock in ' texlabel(nameshocks(taushock(ij),:))];
    hout=suptitle(String1);
end
