function [acheck,betaFullRankcheck,newruntime]  =  ...
    checkprojection2(rho,alf,tau,tau_bar,tau_theta,timeseriesp,A,B,VV,C_tau_N, ...
    J,F,chkproj,T,a,betaFullRank,runtime);

u = rand(3,T);
e = zeros(size(VV,1),T);
e(1,:) = sqrt(VV(1,1))*u(1,:,:);
e(2,:) = e(1,:,:);
e(3,:) = sqrt(VV(3,3))*u(2,:,:);
e(4,:) = e(3,:,:);
e(5,:) = sqrt(VV(5,5))*u(2,:,:);
e(6,:) = sqrt(VV(6,6))*u(3,:,:);
e(7,:) = e(6,:,:);
e(8,:) = sqrt(VV(8,8))*u(3,:,:);

theta = zeros(size(VV,1),T);
z = zeros(size(A,1),T);
X = zeros(size(alf,1),T);


theta(:,1) = e(:,1);
z(:,1) = B*theta(:,1);
X(:,1) = alf + tau*z(:,1) + tau_theta*theta(:,1);

for jjj = 2:T
    theta(:,jjj) = rho*theta(:,jjj-1) + e(:,jjj);
    z(:,jjj) = A*z(:,jjj-1) + B*theta(:,jjj);
    X(:,jjj) = alf + tau*z(:,jjj) + tau_bar*z(:,jjj-1) + tau_theta*theta(:,jjj);
end

ip=size(F,1)-3;
colsJ=size(alf,1);
Xtilda = zeros(size(F,1),T);
Xtilda = J(:,:,1)*X + J(:,:,2)*LagX(X);

w = zeros(size(F,1),T);
Y = zeros(size(F,1),T);
if size(F,1) > 3
R = chol(F)';
w = R*rand(size(F,1),T);
end
Y = Xtilda + w;

%construct the VAR "X" matrix

VARconstant = ones(1,T);
XVar = Y(:,timeseriesp:T-1)';
for ppp = 1:timeseriesp-1
XVar = [XVar Y(:,timeseriesp-ppp:T-1-ppp)'];
end
1+1;
%XVar2 = XVar;
XVar = [ones(T-timeseriesp,1) XVar];

%solve each of the equations in the VAR

acheck = zeros(size(F,1),1);
betaFullRankcheck = zeros(size(F,1),timeseriesp*size(F,1));

for qqq = 1:size(F,1)
BetaOLS = inv((XVar'*XVar))*XVar'*Y(qqq,timeseriesp+1:T)';
%BetaOLS2 = inv((XVar2'*XVar2))*XVar2'*Y(qqq,timeseriesp+1:T)';
acheck(qqq,1) = BetaOLS(1,1)';
betaFullRankcheck(qqq,:) = BetaOLS(2:timeseriesp*size(F,1)+1,1)';
%betaFullRankcheck2(qqq,:) = BetaOLS2(1:timeseriesp*size(F,1),1)';
end
newruntime=cputime-runtime;
adiff = a - acheck;
betaFullRankdiff = betaFullRank - betaFullRankcheck;
%betaFullRankdiff2 = betaFullRank - betaFullRankcheck2;

