function [q,pii,Re,RT,rentk,Retk,w,u,k,invest,y,phi,g,c,uzc] = helpnobank(l,x,muzstar,beta,tauT,tauD,tauk,delta,alpha,psik,psil, ...
    vk,etag,b,lambdaf,entr,upsil,R)

q=1;
u=1;
pii=(1+x)/muzstar;
RT=((muzstar*pii/beta)-1)/(1-tauD);
Re=RT;
Retk=RT*(1-tauD);
rentk= Retk*upsil/((1-tauk)*pii) - (1-delta)/(1-tauk) - upsil*tauk*delta/((1-tauk)*pii) + upsil/((1-tauk)*pii);
if RT <0 | Retk <0 |rentk <0
    error('fatal (helpp) RT or Rk or rk <0')
end

%equation aa1
w           =   ((1-alpha)^(1-alpha)*alpha^alpha/(lambdaf*(rentk*(1+psik*R))^alpha))^(1/(1-alpha))/(1+psil*R);

%equation aa2
lk          =   (1/(muzstar*upsil))*((1-alpha)/alpha)*(rentk*(1+psik*R)/(w*(1+psil*R)));

k           =   l/lk;

invest      =   k*(1-(1-delta)/(muzstar*upsil));

y           =   (vk*((k/(muzstar*upsil))^alpha)*(l^(1-alpha)))/lambdaf;

phi         =   vk*((k/(muzstar*upsil))^alpha)*(l^(1-alpha))*(1-1/lambdaf);

g           =   etag*y;

%equation aa22
c           =   y-invest-g;

%equation aa19
uzc        =  (muzstar-b*beta)/((muzstar-b)*c);

