% myfortran
% F=myfortran(M,nmM) takes the matrix M and a name 'nmM' and returns the matrix entries nmM(i,j)=xx
% written by Gianni Lombardo

function F=myfortran(M,nmM,varargin)
if isempty(varargin)
    truefort=0;
else
    truefort=varargin{1};
end
nzm=(M~=0);
nn=sum(sum(nzm));
F=cell(nn,1);
z=1;
M=sym(M);
for j=1:size(M,1)
    for i=1:size(M,2)
        if M(j,i)~=0
            if truefort
                F{z,1}=[nmM,'(',num2str(j),',',num2str(i),')=',...
                        regexprep(char(vpa(M(j,i),26)), '\^', '**','ignorecase'),';'];
            else
                F{z,1}=[nmM,'(',num2str(j),',',num2str(i),')=',...
                        char(vpa(M(j,i),26)),';'];
            end
            z=z+1;
        end
    end
end

%F=char(F);
