function [] = plotresponses(yhat,ihat,chat,uhat,lhat,what,infhat,pi,Rehatp,Re,qhat,qavrghat,nhatp,premiumhat,Pe,total_loans,tt,String1)

figure
colormap(gray);
cm=colormap;
shdcol=cm(37,:);

subplot(3,4,1)
plot(tt,yhat(tt)*100,'b-')
axis tight
ylabel('percent');
set (gca,'XTicklabel',{''})
title('Output');

subplot(3,4,2)
plot(tt,ihat(tt)*100,'b-');
axis tight
ylabel('percent');
set (gca,'XTicklabel',{''})
title('Investment');

subplot(3,4,3)
plot(tt,chat(tt)*100,'b-');
axis tight
ylabel('percent');
set (gca,'XTicklabel',{''})
title('Consumption');

subplot(3,4,4)
plot(tt,uhat(tt)*100,'b-');
axis tight
ylabel('percent');
set(gca,'Xticklabel',{''});
title('Capacity Utilization ')

subplot(3,4,5)
plot(tt,lhat(tt)*100,'b-');
axis tight
ylabel('percent');
set (gca,'XTicklabel',{''})
title('Hours Worked');

subplot(3,4,6)
plot(tt,what(tt)*100,'b-');
axis tight
set(gca,'Xticklabel',{''});
title('Real Wage')
ylabel('Percent')

subplot(3,4,7)
plot(tt,infhat(tt)*pi*400,'b-');
axis tight
set (gca,'XTicklabel',{''})
title('Inflation (APR)');

subplot(3,4,8)
plot(tt,Rehatp(tt)*Re*400*100,'b-')
axis tight
set(gca,'Xticklabel',{''});
ylabel('basis points')
title('Re (Annual Rate)');

subplot(3,4,9)
if isempty(qavrghat)==1
    plot(tt,qhat(tt)*100,'b-');
    title('Q^M');
else
    plot(tt,qhat(tt)*100,'b-',tt,qavrghat(tt)*100,'r:');
    title('Q^M (solid), Q^A (dotted)');
end
axis tight
%set(gca,'Xticklabel',{''});
ylabel('percent');

subplot(3,4,10)
plot(tt,nhatp(tt)*100,'b-')
axis tight
%set(gca,'Xticklabel',{''});
ylabel('percent');
title('Real Net Worth');

subplot(3,4,11)
plot(tt,premiumhat(tt)*Pe*400*100,'b-')  
axis tight
%set(gca,'Xticklabel',{''});
ylabel('basis points')
title('Premium (Annual Rate)');

subplot(3,4,12)
plot(tt,total_loans(tt)*100,'b-')
axis tight
%set(gca,'Xticklabel',{''});
ylabel('percent');
title('Total Loans (Real)');

hout=suptitle(String1);