function [alphas,alpha_2,alpha_1,alpha_0,betas,D,rho,V_eps,Vmeas,l_psi,l_x,l_eps, ...
    tau,x,gamma,alpha,tauc,taud,beta,b,upsil,ksi,psil,psik,muzstar,Taylor,params, ...
    Re,c,y,invest,w,l,rk,k,n,pii,gov,Pe,G,Gp,omegabar,Rk,Gs,sigma,her,Rb,mb,m,ev,m1,currdep,Ra,R,dm,m3,q,s,u, ...
    lambdaz,uzc,vn,Rm,btot,M] = unld(xx,par,taushock,tauvar,tauvar2,parstoch,XXX,taushock1,taushock3,size_a,size_b,params, ...
 Re,c,y,invest,w,l,k,n,pii,gov,Pe,G,Gp,omegabar,Rk,rk,Gs,her,Rb,mb,ev,m1,currdep,Ra,R,dm,m3,q,s,u,lambdaz,uzc,vn,Rm,btot,M)
   
    
xx   =   map(xx);
undo

V_eps=diag(Recon.^2);
Vmeas=diag(Vmeas.^2);

[rho,D] = maprho(taushock,X,parstoch);

l_x     =   length(tauvar);
l_psi   =   length(rho);
lX      =   length(X);

%load parameters
pibar    = (1+x)/muzstar; %this is an indexing parameter in the price and wage equations with optimal policy, this is a parameter
pitarget = (1+x)/muzstar; %pitarget

params(3)  = lambdaw   ;
params(4)  = sigmaL    ;
params(5)  = theta     ;
params(6)  = v         ;
params(7)  = beta      ;
params(8)  = xiw       ;
params(9)  = Hdoupr    ;
params(10)  = sigmaq    ;
params(11)  = b         ;
params(12)  = psiL      ;
params(13)  = m         ;
params(14)  = chii      ;
params(17)  = iotaw1    ;
params(18)  = iotaw2    ;
params(19)  = iotamu    ;
params(20)  = Fomegabar ;
%params(21)  = sigma     ;
params(22)  = mu        ;
params(23)  = gamma     ;
params(24)  = we        ;
params(25)  = bigtheta  ;
params(26)  = sigmaa    ;
params(27)  = Sdoupr    ;
params(28)  = etai      ;
params(29)  = muup      ;
params(31)  = muzstar   ;
params(32)  = upsil     ;
params(33)  = lambdaf   ;
params(34)  = alpha     ;
params(35)  = psik      ;
params(36)  = psil      ;
params(37)  = delta     ;
params(39)  = xip       ;
params(40)  = iota1     ;
params(41)  = iota2     ;
params(42)  = ksi       ;
params(43)  = xb        ;
params(44)  = chorse    ;
params(46)  = vl        ;
params(47)  = vl        ;
params(48)  = etag      ;
params(49)  = tauk      ;
params(50)  = taul      ;
params(51)  = tauc      ;
params(52)  = taud      ;
params(53)  = taud      ;
params(54)  = tau       ;
params(55)  = x         ;
params(56)  = aptil     ;
params(57)  = aytil     ;
params(58)  = amtil     ;
params(59)  = actil     ;
params(60)  = rhotil    ;
%params(64)  = phi       ;
params(65)  = pibar     ;
params(68)  = pitarget  ;
params(69)  = adptil    ;
params(70)  = adytil    ;
params(78)  = xiE;


if entr ==1 || entr==0 || entr==-1 || entr==2
    estim_ss=0;
    if estim_ss ==0
        [alphas,alpha_2,alpha_1,alpha_0,betas] = newalphabeta(size_a,size_b,sigmaa,xiw,xip,Sdoupr,Hdoupr,rhotil,aptil,aytil,amtil,actil,iota1,iota2,iotaw1,iotaw2,iotamu,adptil,adytil,xiE,par1,par2,par3,par4,par5,par6,par7,par8,par9,par10);
    else
        
        [pii,s,rk,invest,u,omegabar,Rk,n,q,vl,ev,mb,R,uzc,lambdaz,m,Ra,c,w,l,k,kbar,Re,dm,Rm,m3,btot,pstar,wstar, ...
          Fp,Fw,Yz,wplus, ...
          gov,y,phi,RT,m1,Rb,Pe,currdep,costs,vk,pitarget, ...
          psiL,theta,chii,tau, ...
          xb,ksi,psik,psil,chorse,hkb,her,erz, ...
          sigma,vn,bigtheta,mu,we,Fomegabar,pibar,params] = steadystate(rk,params);
            
        icheck=0;
        irun=1;
        if entr==2; params(1)=1; end
        [alphas,alpha_2,alpha_1,alpha_0,betas,beta_0,beta_1,taumat,M,ssvalues,ttt2,G,Gp,Gs] = ...
               makealphabeta(lambdaz,gov,her,ksi,pii,invest,omegabar,Rk,n,ev,mb,uzc,Ra,c,w,Re,m3, ...
               k,params,q,s,u,dm,vn,Re,Rm,icheck,Taylor,forward,parstoch, ...
               etai,taushock,irun,btot,phi,y,R,rk,l,k);
        if entr==2;params(1)=2; end      
    end
    
    if entr ==2
        AF=eye(size(alphas,1));
        Api=zeros(size(alphas,1));

        AF(22,22)=(1+Re)/Re;
        Api(22,1)=(1+Re)/Re;

        alpham1=alpha_0*Api;
        if max(max(abs(alpham1))) > .1e-12
            error('fatal(solvemodel) order of dynamics of system changed with real state noncontingent debt')
        end
        alpha_0=alpha_0*AF+alpha_1*Api;
        alpha_1=alpha_1*AF+alpha_2*Api;
        alpha_2=alpha_2*AF;
        alphas  =  [alpha_0 alpha_1 alpha_2];
    end

elseif entr==-2 || entr==-3 || entr==-4

    %compute steady-state
    if entr==-3 || entr==-4
        [pii,Rk,rk,omegabar,sigma,n,k,invest,w,l,c,y,gov,uzc,lambdaz,Re,pstar,wstar,wplus,Fp,Kp,Fw,Kw,s, ...
            Yz,phi,btot,Pe,vn,q,u] = nobanks_ss(pibar,params);

        params(21)  = sigma;
        params(64)  = phi;

    elseif entr==-2
        [q,pii,Rk,rk,R,pstar,wstar,wplus,k,l,lambdaz,m,mb,c,Yz,gov,invest,Fp,Kp,Fw,Kw,uzc,s,phi,w] ...
            = nobanknoentrss(pibar,params);
        y=c+invest+gov;

        params(64)   = phi;
    end

    %construct alphas and betas
    icheck=0;
    irun=1;
    if entr==-4; params(1)=-3; end
    [alphas,alpha_2,alpha_1,alpha_0,betas,beta_0,beta_1,taumat,M,ssvalues,ttt2,G,Gp,Gs] = ...
        makealphabeta(lambdaz,gov,her,ksi,pii,invest,omegabar,Rk,n,ev,mb,uzc,Ra,c,w,Re,m3, ...
        k,params,q,s,u,dm,vn,Re,Rm,icheck,Taylor,forward,parstoch, ...
        etai,taushock,irun,btot,phi,y,R,rk,l,k);
    if entr==-4;params(1)=-4; end
    
    if entr==-4
        tts = 1:size(variables,1);
    
        AF=eye(size(alphas,1));
        Api=zeros(size(alphas,1));

        AF(tts(ttt2==22),tts(ttt2==22))=(1+Re)/Re;
        Api(tts(ttt2==22),tts(ttt2==1))=(1+Re)/Re;

        alpham1=alpha_0*Api;
        if max(max(abs(alpham1))) > .1e-12
            error('fatal(solvemodel) order of dynamics of system changed with real state noncontingent debt')
        end
        alpha_0=alpha_0*AF+alpha_1*Api;
        alpha_1=alpha_1*AF+alpha_2*Api;
        alpha_2=alpha_2*AF;
        alphas  =  [alpha_0 alpha_1 alpha_2];
    end
    
end
