idat =1;

%cons  = zz1smooth(18,:);
%hours = zz1smooth(20,:);
%wage  = wagek2; %zz1smooth(19,:);
lambdahat = zz1smooth(15,:);
muzhat = psismooth(13,:);

laborwedge(1) = 1;
interwedge(1)=1;
moneywedge(1)=1;

laborwedgea   = -(cons + hours - wage); %construct the gap between the real wage and the marginal rate of substitution

if idat == 1 %if we're coming through here with the actual data, smooth consumption a very small amount before computing the marginal utility of consumption. Otherwise mu will go negative
    lambdahp = 0.5;
    AA        = hpfilt(length(cons),lambdahp);
    concyc   = AA*cons';
    contre   = cons-concyc';
else
    contre = cons;
end

for ii = 2:Quarters-2
    %if ii < (Quarters-1)
        now     = exp(contre(ii))-b*exp(contre(ii-1));
        later   = exp(contre(ii+1))-b*exp(contre(ii));
        later2  = exp(contre(ii+2))-b*exp(contre(ii+1));
        muc(ii) = 1/now - b*beta/later;
        muc2(ii) = 1/later - b*beta/later2;
        if muc(ii) < 0
            disp('fatal (prepare_short) negative marginal utility of consumption')
        end
        laborwedge(ii) = -( -log(muc(ii))+hours(ii)-wage(ii) );
        interwedge(ii) = log(muc(ii)) - beta*log(muc2(ii)) - Re_series(ii);
    %end
end

muzstart = muzstar*(muzhat+1);
zt(1)     = muzstart(1); %this is z*(t)
for t=2:Quarters
    zt(t)     = zt(t-1)*muzstart(t);
end

moneywedge = (lambdahat(1:81)-pricek2(1:81)-zt(1:81)) - log(muc);

firmwedge = output-hours-wage;

figure
subplot(2,2,1)
plot(date(5:81),laborwedge(5:81))
title('labor mark up')
axis tight

subplot(2,2,2)
plot(date(5:81),firmwedge(5:81))
title('price mark up')
axis tight

subplot(2,2,3)
plot(date(5:81),interwedge(5:81))
title('intertemporal wedge')
axis tight

subplot(2,2,4)
plot(date(5:81),moneywedge(5:81))
title('money wedge')
axis tight
