% to run this, first load data.
clg
tt=1:2*lag+1;
t1=tt-lag-1;
v=[-5 5 -1 1];
axis(v)
subplot(221)
rho=Beb(1,tt);
rho1=rho+2*Beb(2,tt);
rho2=rho-2*Beb(2,tt);
plot(t1,rho1,t1,rho,t1,rho2)
title('establishment bodies')
ylabel('corr(n(t),w(t-tau))')
xlabel('tau')
subplot(222)
rho=Beh(1,tt);
rho1=rho+2*Beh(2,tt);
rho2=rho-2*Beh(2,tt);
plot(t1,rho1,t1,rho,t1,rho2)
title('establishment hours')
ylabel('corr(n(t),w(t-tau))')
xlabel('tau')
%
subplot(223)
rho=Bghb(1,tt);
rho1=rho+2*Bghb(2,tt);
rho2=rho-2*Bghb(2,tt);
plot(t1,rho1,t1,rho,t1,rho2)
title('Gary Hansen bodies')
ylabel('corr(n(t),w(t-tau))')
xlabel('tau')
subplot(224)
rho=Bghh(1,tt);
rho1=rho+2*Bghh(2,tt);
rho2=rho-2*Bghh(2,tt);
plot(t1,rho1,t1,rho,t1,rho2)
title('Gary Hansen hours')
ylabel('corr(n(t),w(t-tau))')
xlabel('tau')
%meta fig1
pause
clg
subplot(221)
rho=Bhb(1,tt);
rho1=rho+2*Bhb(2,tt);
rho2=rho-2*Bhb(2,tt);
plot(t1,rho1,t1,rho,t1,rho2)
title('household bodies')
ylabel('corr(n(t),w(t-tau))')
xlabel('tau')
%meta fig2
