%  this loads the hp-filtered data
%  and produces some scatter plots
load data
v=[-.05 .05 -.05 .05];
axis(v)
tt1=3:length(eby);
tt2=1:length(eby)-2;
subplot(221)
plot(ebyn,ebn,'*')
title('establishment bodies')
xlabel('productivity')
ylabel('hours')
subplot(222)
plot(ebyn(tt2),ebn(tt1),'*')
title('establishment bodies')
xlabel('productivity')
ylabel('hours, t+2')
subplot(223)
plot(ehyn,ehn,'*')
title('establishment hours')
xlabel('productivity')
ylabel('hours')
subplot(224)
plot(ehyn(tt2),ehn(tt1),'*')
title('establishment hours')
xlabel('productivity')
ylabel('hours, t+2')
pause
clg
subplot(221)
plot(hbyn,hbn,'*')
title('household bodies')
xlabel('productivity')
ylabel('hours')
subplot(222)
plot(hbyn(tt2),hbn(tt1),'*')
title('household bodies')
xlabel('productivity')
ylabel('hours, t+2')
meta fig1
pause
clg
tt1=3:length(ghby);
tt2=1:length(ghby)-2;
subplot(221)
plot(ghbyn,ghbn,'*')
title('Gary Hansen bodies')
xlabel('productivity')
ylabel('hours')
subplot(222)
plot(ghbyn(tt2),ghbn(tt1),'*')
title('Gary Hansen bodies')
xlabel('productivity')
ylabel('hours, t+2')
subplot(223)
plot(ghhyn,ghhn,'*')
title('Gary Hansen hours')
xlabel('productivity')
ylabel('hours')
subplot(224)
plot(ghhyn(tt2),ghhn(tt1),'*')
title('Gary Hansen hours')
xlabel('productivity')
ylabel('hours, t+2')
pause
clg
meta fig2
