
l_xx_rec = find(date==end_rec)-find(date==init_rec);
xx_rec   = zeros(l_xx_rec,length(xx));
mean_rec_mat = zeros(l_xx_rec,size(XXX,1));

estimm = [find(date==init_rec):yperiods:find(date==end_rec)-1];

if isempty(find(date==end_rec))
    error('fatal (forecastkal_rec) end_rec falls outside available sample')
end

xx_fullsample = xx;
mean_fullsample = zeros(size(meanxxx));
mean_fullsample(r_mm) = meanxxx(r_mm); %when computing forecast errors we remove the mean from XXX only as concern variables in r_mmm set above

ij = 1;
for TT = find(date==end_rec)-1:-1:find(date==init_rec)
    [Xdat,mm,meanxxx_rec] = demeandata(XXX,find(date==start_estimation),TT,TT,init_kalman,demean,mm,entr,country,pi,Re,R,Ra);
    Xdat = J*Xdat(:,find(date==start_estimation):TT);
    if max(estimm==TT)==1
        maximize  %
        xx_rec(l_xx_rec+1-ij,:) = xxnew;
        xx = xxnew; 
    else
        xx_rec(l_xx_rec+1-ij,:) = xx;
    end
    save([outfolder '\rmsfe_cmr'],'xx_rec')
    
    [Yhat_rec,pi,Re,Ra,R] = forecast_rec_do(xx,TT,meanxxx,trendm3,trendm1,date,LL,outfolder, ...
        accuracy,par,taumat,her,Rb,Re,c,y,i,mb,w,l,k,n,pi,g,ev,taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat, ...
        J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,taushock1,R,ttt2, ...
        entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,shockss,user);

    mean_rec_ = zeros(size(meanxxx_rec));
    if demean == 1
        recent_mean=0; %=1 in computing forecast error, use recent mean rather than mean of full sample used in the estimation;
        if recent_mean ==1
            [Xdat,mm,meanxxx_rec] = demeandata(XXX,TT-12-init_kalman,TT,TT,init_kalman,demean,mm,entr,country,pi,Re,R,Ra);
        end
        mean_rec_ = meanxxx_rec;
        mean_rec_(r_mm) = 0;
        mean_rec_mat(l_xx_rec+1-ij,:) = mean_rec_';
    end
    
    TTt = TT+1:TT+min(LL,find(date==end_rec)-TT);
    eee_cmr{l_xx_rec+1-ij} = J*(XXX(:,TTt)-mean_fullsample*ones(1,length(TTt)) ) - (Yhat_rec(:,TTt) + mean_rec_(tauvar)*ones(1,length(TTt)) );
    ij = ij+1;
end

%COMPUTE RMSE
index_r = find(index_r==0);
std_rec_data = std((J*XXX(:,find(date==init_rec):find(date==end_rec))),1,2); %this is needed to construct the scale matrix used in multivariate measures of fit

[rmse_cmr,rmse_4_cmr,mae_cmr,mae_4_cmr,mmse_det_cmr,mmse_tr_cmr,for_errors_cmr,mmse_new_cmr,UU_cmr] = rmse_(LL,eee_cmr,index_r,std_rec_data,taufor);

if entr==1
 save([outfolder '\rmsfe_cmr'], 'xx_rec', 'rmse_cmr', 'rmse_4_cmr', 'mae_cmr', 'mae_4_cmr', 'mmse_det_cmr', 'mmse_tr_cmr', 'for_errors_cmr')
elseif entr==-2
 xx_rec_sw = xx_rec;
 rmse_sw=rmse_cmr; rmse_4_sw=rmse_4_cmr; mae_sw=mae_cmr; mae_4_sw=mae_4_cmr; mmse_det_sw=mmse_det_cmr; mmse_tr_sw=mmse_tr_cmr; for_errors_sw=for_errors_cmr;
 save([outfolder '\rmsfe_sw'], 'xx_rec_sw', 'rmse_sw', 'rmse_4_sw', 'mae_sw', 'mae_4_sw', 'mmse_det_sw', 'mmse_tr_sw', 'for_errors_sw')
elseif entr ==-3
 xx_rec_bgg = xx_rec;
 rmse_bgg=rmse_cmr; rmse_4_bgg=rmse_4_cmr; mae_bgg=mae_cmr; mae_4_bgg=mae_4_cmr; mmse_det_bgg=mmse_det_cmr; mmse_tr_bgg=mmse_tr_cmr; for_errors_bgg=for_errors_cmr;
 save([outfolder '\rmsfe_bgg'], 'xx_rec_bgg', 'rmse_bgg', 'rmse_4_bgg', 'mae_bgg', 'mae_4_bgg', 'mmse_det_bgg', 'mmse_tr_bgg', 'for_errors_bgg')
end

%---------------------------------------------------------
%  PLOT RESULTS OF RECURSIVE ESTIMATION
%---------------------------------------------------------

%Plot RMSE
[nameshocks,nameXXX] = getnames(fdiff);

figure, orient landscape
for jj=1:size(rmse_cmr,1)
    subplot(4,4,jj)
    plot(1:LL,rmse_cmr(jj,:))
    title(nameXXX(tauvar(jj),:))
    %set (gca,'XTick',[0 21])
    axis tight
end
hout=suptitle('Figure: RMSFE(percent terms): DSGE model');

figure, orient landscape
for jj=1:size(rmse_cmr,1)
    subplot(4,4,jj)
    plot(1:LL,rmse_4_cmr(jj,:))
    title(nameXXX(tauvar(jj),:))
    %set (gca,'XTick',[0 21])
    axis tight
end
hout=suptitle('Figure: RMSFE (y-o-y percent terms): DSGE model');

figure, orient landscape
for jj=1:size(rmse_cmr,1)
    subplot(4,4,jj)
    plot(1:LL,mae_cmr(jj,:))
    title(nameXXX(tauvar(jj),:))
    %set (gca,'XTick',[0 21])
    axis tight
end
hout=suptitle('Figure: MAFE(percent terms): DSGE model');

figure, orient landscape
subplot(1,2,1)
plot(1:LL,mmse_det_cmr)
axis tight
subplot(1,2,2)
plot(1:LL,mmse_tr_cmr)
%set (gca,'XTick',[0 21])
axis tight
hout=suptitle('Figure: Multivariate Measures: log determinant (left) and trace (right). DSGE model');

doplot = 1; %=1 plot the eigenvalues and eigenvectors
if doplot==1
    figure; orient landscape
    for h=1:LL
        subplot(3,4,h)
        plot(1:length(std_rec_data(taufor)),mmse_new_cmr(:,h))
        title(['Horizon ' num2str(h)])
        axis tight
    end
    hout=suptitle('Figure: Eigenvalues of the MSE matrix at Different Horizons');

    figure; orient landscape
    for ii=1:length(std_rec_data(taufor))
        UU_ = reshape(UU_cmr(:,ii,:).^2,length(std_rec_data(taufor)),LL);
        subplot(4,4,ii)
        bar(1:LL,UU_','stacked')
        %colormap(cmap)
        axis tight
        xlabel('Horizon')
        title(['Eigenvalue no. ' num2str(ii)])
    end
    hout=suptitle('Relative Contribution to the Eigenvalues of MSE Matrix (square of the elements in the eigenvector)');
    nameXXX_ = nameXXX(tauvar,:);
    leg = legend(nameXXX_(taufor,:));
    set(leg, 'FontSize', 7,'Location','SouthEast');
end

n2=2;
if LL>8
    n2 = 3;
end
for kk = 1:length(std_rec_data)
    figure; orient landscape
    for hhh =1:LL
        t2 = date(find(date==init_rec)+hhh:find(date==end_rec));
        subplot(4,n2,hhh)
        plot(t2,100*abs(for_errors_cmr{:,:,kk,hhh}))
        axis tight
        title([num2str(hhh) ' step ahead'])
    end
    hout=suptitle([deblank(nameXXX(tauvar(kk),:)) ': ' 'Absolute Forecast Errors (percent terms) at Different Horizons']);
end

%---------------------------------------------------------
%Plot Recursive Forecast as a movie
%---------------------------------------------------------
nxn = 5; %location of the variable you want to display. It refers to full list of variables, not location in tauvar

t_rec = find(date==init_rec)-24:find(date==end_rec); %12 is the number of quarters we want to display the data prior to the start of recursive estimatimation

figure
plot(date(t_rec),400*(XXX(nxn,t_rec)-mean_fullsample(nxn)*ones(1,length(t_rec))),'k-', 'LineWidth',2)
hold on

meanxxx_plot = meanxxx;
meanxxx_plot(r_mm) = 0;
plot(date(t_rec),400*meanxxx_plot(nxn)*ones(1,length(t_rec)),'k-','LineWidth',1);

title(nameXXX(nxn,:));
for jj=1:size(eee_cmr,2)
    ee_ = eee_cmr{jj};
    ee_xxx = J*(XXX(:,find(date==init_rec)+jj-1:find(date==init_rec)+jj+size(ee_,2)-1) - mean_fullsample*ones(1,size(ee_,2)+1)) - [zeros(size(ee_,1),1),ee_]; %we want that the first observation shown in the chart is the last inside the sample.

    plot(date(find(date==init_rec)+jj-1:find(date==init_rec)+jj+size(ee_,2)-1),400*ee_xxx(find(tauvar==nxn),:),'r-')
    
    if fdiff ==1
         plot(date(find(date==init_rec)+jj),400*mean_rec_mat(jj,nxn),'rd');
    end
    pause(1)
end
hold off
hout=suptitle(['Recursive Forecast. Model is Re-estimated every ' num2str(yperiods) ' Quarters']);


%--------------------------------------------------------
%Plot Recursive Estimates of Model's Parameters
%--------------------------------------------------------
nxn =28; %number of subplot in the first chart

for jj = 1:size(xx_rec,1)
    xx_rec_(jj,:) = map(xx_rec(jj,:));
end
xx_rec_ = [xx_rec_; map(xx_fullsample)];

figure, orient landscape
jj=1;
while jj <= nxn
    subplot(4,7,jj)
    plot(date(find(date==init_rec):find(date==end_rec)),xx_rec_(:,jj))
    title(xxname3(jj,:))
    axis tight
    jj=jj+1;
end
hout=suptitle(['Recursive Posterior Mode Estimates of Model''s Parameters. Model is Re-estimated every ' num2str(yperiods) ' Quarters']);

if size(xx_rec,2) > nxn
figure, orient landscape
jjj=1;
for jj = nxn+1:size(xx_rec,2)
    subplot(4,7,jjj)
    plot(date(find(date==init_rec):find(date==end_rec)),xx_rec_(:,jj))
    title(xxname3(jj,:))
    axis tight
    jjj=jjj+1;
end
end
hout=suptitle(['Recursive Posterior Mode Estimates of Model''s Parameters. Model is Re-estimated every ' num2str(yperiods) ' Quarters']);


