function [X] = imap2(D,rho,taushock,Taylor,tiny,mb)

if nargin == 5
    mb=0;
end
   
i=0;

for ii = 1:length(taushock)
    
    sss=[(taushock(ii)-1)*3+[1:3]];
    d=D(sss,taushock(ii));    
    rrho=rho(sss,sss);
    rhof=min(rrho(1,1),1-tiny);
    rhof=max(rhof,tiny);
    theta2=min(rrho(3,3),1-tiny);
    theta2=max(theta2,tiny);
    theta1=rrho(3,2);
    phi0=d(3,1);
    
    if Taylor ~= -1
        if taushock(ii) ~= 19
            X(i+1)=-log((1/rhof)-1); 
            X(i+2)=-log((1/theta2)-1);
            X(i+3)=(phi0);
            if mb == 1;X(i+4)=theta1;end
            i=length(X);
        elseif taushock(ii) == 19
            X(i+1)=-log((1/rhof)-1); 
            i=length(X);
        end           
    elseif Taylor == -1
        X((ii-1)+1)=-log((1/rhof)-1); 
    end
    
end