function [D,rho] = map1(X,taushock,Taylor)

mb=0;
if length(X)/length(taushock) == 4;
    mb=1;
end

i=0;
rho=zeros(63,63);
D=zeros(63,21);

for ii = 1:length(taushock)
    if Taylor ~= -1
        if taushock(ii) ~= 19
            x1=X(i+1);
            x2=X(i+2);
            x3=X(i+3);
            if mb == 1;
                phi1=X(i+4);
            end
            
            rhof=1/(1+exp(-x1));
            phi2=1/(1+exp(-x2));
            phi0=(x3);
            
            pp=[rhof phi2 phi0];
            if mb == 1;
                pp=[rhof phi2 phi0 phi1] ;
            end
            
            if max(abs(imag(pp))) > .1e-9
                error(' (map1) encounted complex parameter values  ')
            end
            
            d=[ 1 1 phi0 ]';
            rrho=[rhof 0 0; 0 0 0; 0 0 phi2]; 
            if mb == 1;
                rrho(3,2)=phi1;
            end
            
            if taushock(ii) == 21
                d=[ 1 0 phi0 ]';
                rrho=[rhof 0 0; 1 0 0; 0 0 phi2];
            end
            
            sss=[(taushock(ii)-1)*3+[1:3]];
            D(sss,taushock(ii))=d;    
            rho(sss,sss)=rrho;
            if mb == 1
                i=i+4;
            else                
                i=i+3;
            end
            
        elseif taushock(ii) == 19
            x1=X(i+1);
            rhof=1/(1+exp(-x1));
            if max(abs(imag(rhof))) > .1e-9
                error(' (map1) encounted complex parameter values  ')
            end
            d=[ 1 0 0 ]';
            rrho=[rhof 0 0; 0 0 0; 0 0 0];    
            sss=[(taushock(ii)-1)*3+[1:3]];
            D(sss,taushock(ii))=d;    
            rho(sss,sss)=rrho;
            i=i+1;
        end
    elseif Taylor == -1
        if Taylor == -1
            error('fatal (map1) taylor = -1 and code is not ready')
        end
        x1=X(((ii)-1)+1);
        rhof=1/(1+exp(-x1));
        if max(abs(imag(rhof))) > .1e-9
            error(' (map1) encounted complex parameter values  ')
        end
        d=[ 1 1 0 ]';
        rrho=[rhof 0 0; 0 0 0; 0 0 0]; 
        sss=[(taushock(ii)-1)*3+[1:3]];
        D(sss,taushock(ii))=d;    
        rho(sss,sss)=rrho;
        if taushock(ii) == 21
            d=[ 1 0 0 ]';
            rrho=[rhof 0 0; 1 0 0; 0 0 0];    
            sss=[(21-1)*3+[1:3]];
            D(sss,21)=d;    
            rho(sss,sss)=rrho;
        end
    end
end
