function [rho,D] = maprho(taushock,X,parstoch)
full=1;%if = 1, have a full stream of signals.
nshk=length(taushock);

if length(X) ~= 2*nshk;error('fatal (maprho) wrong lengths');end

parstoch1=X([1:nshk]);
parstoch2=X([nshk+1:2*nshk]);
   
rho = [];
D   = [];

for i=1:length(taushock)
    rho1   =  [parstoch1(i),parstoch2(i);1,0];
    
    d1     =  [1 0]';
    if parstoch(taushock(i)) > 0
        rho1 = zeros(parstoch(taushock(i))+2,parstoch(taushock(i))+2);
        rho1(1:2,1:2)  = [parstoch1(i),parstoch2(i);1,0];
        rho1(1,end) = 1;

        if full == 0
            d1      =  zeros(parstoch(taushock(i))+2,2);
            d1(1,1) =  1;
            d1(3,2) =  1;
        elseif full == 1
            d1      = eye(parstoch(taushock(i))+1);
            d1      = [d1(1,:)
                zeros(1,size(d1,2))
                d1(2:end,:)];
        end
                   
        if parstoch(taushock(i)) >= 2
            rho1(4:end,3:end-1)=eye(parstoch(taushock(i))-1,parstoch(taushock(i))-1);
        end
    end
    rho = blkdiag(rho, rho1);
    D   = blkdiag(D, d1);
    
    rho1 = [];
    d1   = [];
end