function [infl,Rk,rk,omegabar,sigma,n,k,invest,w,h,c,y,g,ucz,lambdaz,R,pstar,wstar,wplus,Fp,Kp,Fw,Kw,s,yz, ...
    phi,btot,Pe,vn,q,u] = nobanks_ss(pibar,parameters) 

lambdaw   = parameters(3);
sigmaL    = parameters(4);
beta      = parameters(7);
xiw       = parameters(8);
b         = parameters(11);
psiL      = parameters(12);
zetac     = parameters(16);
iotaw1    = parameters(17);
iotaw2    = parameters(18);
iotamu    = parameters(19);
Fomegabar = parameters(20);
mu        = parameters(22);
gamma     = parameters(23);
we        = parameters(24);
bigtheta  = parameters(25);
sigmaa    = parameters(26);
Sdoupr    = parameters(27);
etai      = parameters(28);
muup      = parameters(29);
zeta      = parameters(30);
muzstar   = parameters(31);
upsil     = parameters(32);
lambdaf   = parameters(33);
alpha     = parameters(34);
psik      = parameters(35);
psil      = parameters(36);
delta     = parameters(37);
epsil     = parameters(38);
xip       = parameters(39);
iota1     = parameters(40);
iota2     = parameters(41);
etag      = parameters(48);
tauk      = parameters(49);
taul      = parameters(50);
tauc      = parameters(51);
taud      = parameters(52);
begin  = parameters(71);

infl = pibar;

%we need to first compute phi. This is set to a value which implies
%steady state profits are zero in the case: pibar=steady-state inflation
phi=0;%by setting phi=0, you trigger the steadystate.m into computing phi so that profits are zero in steady state

[rk,n,k,h,invest,w,d,c,lambdaz,yz,sigma,omegabar,phi,s,pitild,pstar,piw, ...
    pitildw,wstar,wplus,Rk,R,Fp,Kp,Fw,Kw,ucz,q,Gamma,Gam_muG,g,y] = nobanks_ss1(lambdaf,infl, ...
    muzstar,beta,delta,Fomegabar,mu,alpha,gamma,sigmaL, ...
    psiL,lambdaw,we,bigtheta,b,phi, ...
    muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2, ...
    xiw,epsil,etag,zeta,zetac,taul,psik,psil,tauc,taud);

if begin ==1
    btot = (k-n)/(infl*muzstar);%this is total loans scaled by P(t)z*(t)
elseif begin ==0
    btot = (k-n);
end

full = 0; %=1, compute all outputs; =0, compute G only and set to zero the others terms
G = const(omegabar,sigma,mu,full);

Pe = mu*G*(1+Rk)*k/(k-n); %external finance premium
vn = (1/gamma)*(n-we);

q=1;
u=1;