if country ==1
    country_string = 'ea';
else
    country_string = 'us';
end

cdir = cd;
curdrive = strrep(cdir,namedir,'');

outfolder = ['.\results_' country_string];
if exist(outfolder)~=7 %=7 assess whether the name does not clash with the name of another directory
    mkdir(outfolder); %create directory
end

if user ==0

    addpath([curdrive 'codelev']);
    addpath([curdrive 'newandersen']);
    addpath([curdrive 'euroarea_data']);
    addpath([curdrive 'us_data']);
    addpath([curdrive 'Kalman']);
    addpath([curdrive 'KPMstats']);
    addpath([curdrive 'KPMtools']);
    addpath([curdrive 'AIM']);
    addpath([curdrive 'optimisation\sim_anneal_goffe']);
    addpath([curdrive 'optimisation\SolvOpt']);
    addpath([curdrive 'optimisation\adap_sim_anneal_ingber\asamin']);

elseif user ==1

    addpath c:\projects\solve\code
    addpath c:\projects\solve\newandersen
    addpath c:\projects\ecb\kalman
    addpath c:\projects\ecb\kpMstats
    addpath c:\projects\ecb\kpMtools
    addpath c:\projects\solve\sim_annealing
    addpath c:\projects\ecb\April2005\optimisation\SolvOpt
end

save([cdir '\wherearewe'], 'user', 'outfolder');
