function [floglik,cost_flag,H,F,Q,initV,is,alf,RR,V_eps]   =  ssloglik(xx,par,taumat,her,Rb,Re,c,y,invest,mb,w,l,k,n,pii,g,ev,taushock,Pe,G,Gp, ...
    omegabar,Rk,rk,Gs,fdiff,XXX,J,ric,M,m1,currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b, ...
    prior,taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman)
         
cost_flag=1;
%varargout(1)={cost_flag};

try
    %unload parameters and construct alphas and betas
    [alphas,alpha_2,alpha_1,alpha_0,betas,D,rho,V_eps,RR,l_psi,l_x,l_eps, ...
    tau,x,gamma,alpha,tauC,taud,beta,b,upsil,ksi,psil,psik,muzstar,Taylor,params,Re,c,y,invest,w,l, ...
    rk,k,n,pii,g,Pe,G,Gp,omegabar,Rk,Gs,sigma,her,Rb,mb,m,ev,m1,currdep,Ra,R,dm,m3,q,s,u,lambdaz,uzc,vn,Rm,btot,M] = ...
    unld(xx,par,taushock,tauvar,tauvar2,parstoch,XXX,taushock1,taushock3,size_a,size_b,params, ...
    Re,c,y,invest,w,l,k,n,pii,g,Pe,G,Gp,omegabar,Rk,rk,Gs,her,Rb,mb,ev,m1,currdep,Ra,R,dm,m3,q,s,u,lambdaz,uzc,vn,Rm,btot,M);
     
    %solve the model
    hmat  =  [alpha_2 alpha_1 alpha_0];
    nlag  =  1; %Number of lags
    nlead =  1; %Number of leads
    condn = 1e-8; %Zero tolerance used as a condition number test by numeric_shift and reduced_form
    uprbnd = 1; %Inclusive upper bound for the modulus of roots allowed in the reduced form
    [A,rts,ia,nexact,nnumeric,lgroots,aimcode] =  SPAmalg(hmat,size(hmat,1),nlag,nlead,condn,uprbnd);
    
    l_z = length(A);
    
    [H,F,Q,initV,is,alf]  =   kalman_matrices(D,rho,V_eps,A,alphas,betas,taumat, ...
        tau,her,ksi,Rb,Re,c,y,invest,mb,m,x,psil,w,l,psik,rk,k,muzstar,n,pii,g,ev, ...
        taushock,Pe,G,Gp,omegabar,Rk,Gs,sigma,Taylor,fdiff,J,ric,M,m1,upsil,currdep,Ra,dm,m3,demean,mm, ...
        parstoch,l_eps,duration1,beta,tauvar,RR,gamma,alpha,R,ttt2,entr,tauC,duration2,taud,params);
    
    alt = 0;%if = 1, just use the prior constructed in 'mother'.
    if alt ~= 1
        if is == 1
            initxi  =   zeros(2*(l_z+l_psi),1);
        else
            initxi  =   zeros(2*l_z+l_psi,1);
        end

        %[x, V, VV, floglik] = kalman_filter(XXX,F,H,Q,RR,initxi,initV);
        %[x, V, VV, floglik] = kalman_filter(XXX,F,H,Q,RR,initxi,initV,alf);

        if init_kalman > 0
            [initxi,initV1] = initmykalman(XXX,F,H,Q,RR,initxi,initV,alf,init_kalman);
        else
            iniV1 = initV;
        end
        [floglik] = mykalman(XXX(:,init_kalman+1:end),F,H,Q,RR,initxi,initV1,alf); %based on Durbin and Koopman's paper
        lnpriormom = 0;    
        %[lnpriormom] = mother(XXX(:,init_kalman+1:end),initV,RR,H,F,alf);

    else

        [lnpriormom] = mother(XXX(:,init_kalman+1:end),initV,RR,H,F,alf);
        floglik=0;

    end
    
    xy=map(xx);
    log_prior = priordens(xy,prior);

    floglik = floglik + log_prior + real(lnpriormom);
      
    floglik  =   -floglik;

    if abs(imag(floglik)) > 0
        floglik = 20e12;
    end 
    if isnan(floglik)
        floglik = 30e12;
    end
    
catch
    lasterr
    floglik = 40e12;
end
%save d:\banking\euroarea_code\V_epsilon V_eps